/* mainController */

#import <Cocoa/Cocoa.h>

@interface mainController : NSObject
{
    IBOutlet id gameListBox;
    IBOutlet id NSDrawer1;
    IBOutlet id tableView;
    IBOutlet id totalServers;
    IBOutlet id statusText;
    IBOutlet id rulesView;
    IBOutlet id playersView;
    IBOutlet id favoritesView;
    IBOutlet id getButton;
    id current_object;
    IBOutlet id querySpeed;
    IBOutlet id thisWindow;
    IBOutlet id tabView;
    bool refreshing;
    int sockfd;
    
    bool stopThread;
    
    char handoff[16];
    char gameType[256];
    char currentEngine[20];
    char gameName[256];
    
    int queried;
    id current_tv;
    NSMutableArray *games;
    NSMutableArray *rules;
    NSMutableArray *games_list;
    NSMutableArray *players;
    NSMutableArray *favorites;
}
- (IBAction)getServersButton:(id)sender;
- (IBAction)refreshServersButton:(id)sender;
- (IBAction)addFavButton:(id)sender;
- (IBAction)addCustomdFavButton:(id)sender;
- (IBAction)removeFav:(id)sender;
- (void)standardError:(NSString*)smallError error:(NSString*)bigError;
- (void)startListenServer;
- (void)getServers;
- (void)parseIPList:(unsigned char*)packet;
- (void)queryServers;
- (void)queryGamespyList:(unsigned char *)packet length:(int)len;
- (void)queryGamespyServer:(char*)ip port:(unsigned short)port;
- (void)loadGames;
- (void)addGamesToList;
- (void)getGamespyDetails:(int)index;
/* Gamespy */
- (int) handleDelim1:(unsigned char*)packet delim:(char)delim;
- (void)parseGamespyInfoResponse:(char*)buf ip:(char*)ip port:(unsigned short)port obj:(id)object;
- (void)queryq3Server:(char*)ip port:(unsigned short)port;
- (void)parseq3InfoResponse:(char*)buf ip:(char*)ip port:(unsigned short)port obj:(id)object;
- (int) handleDelim:(unsigned char*)packet;
- (void)refreshList:(id)object;
- (int)numberOfRowsInTableView:(NSTableView *)aTableView;
- (id)tableView:(NSTableView *)aTableView 
    objectValueForTableColumn:(NSTableColumn *)aTableColumn
    row:(int)rowIndex;

@end
